
"""standard optik/optparse setup for all cuisine tools. optparse is extended to
know some additional useful types.

use options.CuisineOptionParser(usage="...") as your optionparser

"""


from optparse import OptionParser,OptionValueError,Option
from copy import copy
from cuisine.desctypes import Duration

# this should all be the start of the cuisine OptionParser subclass
def _check_duration(option,opt,value):
    try:
        return Duration(value)
    except ValueError:
        raise OptionValueError("option %s: %r is not a duration such as '5fr' or '-2.1s'" % (opt,value))
class _CuisineOption(Option):
    TYPES = Option.TYPES + ("duration",)
    TYPE_CHECKER = copy(Option.TYPE_CHECKER)
    TYPE_CHECKER["duration"] = _check_duration

def CuisineOptionParser(*arg,**kwarg):
    return OptionParser(option_class=_CuisineOption,*arg,**kwarg)
